// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from oxts_msgs:msg/NavSatRef.idl
// generated code does not contain a copyright notice
#include "oxts_msgs/msg/detail/nav_sat_ref__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
oxts_msgs__msg__NavSatRef__init(oxts_msgs__msg__NavSatRef * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    oxts_msgs__msg__NavSatRef__fini(msg);
    return false;
  }
  // latitude
  // longitude
  // altitude
  // heading
  return true;
}

void
oxts_msgs__msg__NavSatRef__fini(oxts_msgs__msg__NavSatRef * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // latitude
  // longitude
  // altitude
  // heading
}

bool
oxts_msgs__msg__NavSatRef__are_equal(const oxts_msgs__msg__NavSatRef * lhs, const oxts_msgs__msg__NavSatRef * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // latitude
  if (lhs->latitude != rhs->latitude) {
    return false;
  }
  // longitude
  if (lhs->longitude != rhs->longitude) {
    return false;
  }
  // altitude
  if (lhs->altitude != rhs->altitude) {
    return false;
  }
  // heading
  if (lhs->heading != rhs->heading) {
    return false;
  }
  return true;
}

bool
oxts_msgs__msg__NavSatRef__copy(
  const oxts_msgs__msg__NavSatRef * input,
  oxts_msgs__msg__NavSatRef * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // latitude
  output->latitude = input->latitude;
  // longitude
  output->longitude = input->longitude;
  // altitude
  output->altitude = input->altitude;
  // heading
  output->heading = input->heading;
  return true;
}

oxts_msgs__msg__NavSatRef *
oxts_msgs__msg__NavSatRef__create()
{
  oxts_msgs__msg__NavSatRef * msg = (oxts_msgs__msg__NavSatRef *)malloc(sizeof(oxts_msgs__msg__NavSatRef));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(oxts_msgs__msg__NavSatRef));
  bool success = oxts_msgs__msg__NavSatRef__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
oxts_msgs__msg__NavSatRef__destroy(oxts_msgs__msg__NavSatRef * msg)
{
  if (msg) {
    oxts_msgs__msg__NavSatRef__fini(msg);
  }
  free(msg);
}


bool
oxts_msgs__msg__NavSatRef__Sequence__init(oxts_msgs__msg__NavSatRef__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  oxts_msgs__msg__NavSatRef * data = NULL;
  if (size) {
    data = (oxts_msgs__msg__NavSatRef *)calloc(size, sizeof(oxts_msgs__msg__NavSatRef));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = oxts_msgs__msg__NavSatRef__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        oxts_msgs__msg__NavSatRef__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
oxts_msgs__msg__NavSatRef__Sequence__fini(oxts_msgs__msg__NavSatRef__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      oxts_msgs__msg__NavSatRef__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

oxts_msgs__msg__NavSatRef__Sequence *
oxts_msgs__msg__NavSatRef__Sequence__create(size_t size)
{
  oxts_msgs__msg__NavSatRef__Sequence * array = (oxts_msgs__msg__NavSatRef__Sequence *)malloc(sizeof(oxts_msgs__msg__NavSatRef__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = oxts_msgs__msg__NavSatRef__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
oxts_msgs__msg__NavSatRef__Sequence__destroy(oxts_msgs__msg__NavSatRef__Sequence * array)
{
  if (array) {
    oxts_msgs__msg__NavSatRef__Sequence__fini(array);
  }
  free(array);
}

bool
oxts_msgs__msg__NavSatRef__Sequence__are_equal(const oxts_msgs__msg__NavSatRef__Sequence * lhs, const oxts_msgs__msg__NavSatRef__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!oxts_msgs__msg__NavSatRef__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
oxts_msgs__msg__NavSatRef__Sequence__copy(
  const oxts_msgs__msg__NavSatRef__Sequence * input,
  oxts_msgs__msg__NavSatRef__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(oxts_msgs__msg__NavSatRef);
    oxts_msgs__msg__NavSatRef * data =
      (oxts_msgs__msg__NavSatRef *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!oxts_msgs__msg__NavSatRef__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          oxts_msgs__msg__NavSatRef__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!oxts_msgs__msg__NavSatRef__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
